//
//  keyPressed.cpp
//  collide
//
//  Created by Andrew Lee on 11/13/15.
//
//

#include "keyPressed.hpp"

void testApp::keyPressed(int key) {
    if(key == '1'){ currentSound = 0; keyPressed('r');}
    if(key == '2'){ currentSound = 1; keyPressed('r');}
    if(key == '3'){ currentSound = 2; keyPressed('r');}
    if(key == '4'){ currentSound = 3; keyPressed('r');}
    if(key == '5'){ currentSound = 4; keyPressed('r');}
    if(key == '6'){ currentSound = 5; keyPressed('r');}
    if(key == '7'){ currentSound = 6; keyPressed('r');}
    if(key == '8'){ currentSound = 7; keyPressed('r');}
    if(key == '9'){ currentSound = 8; keyPressed('r');}
    if(key == '0'){ currentSound = 9; keyPressed('r');}
    if(key == '-'){ currentSound = 10; keyPressed('r');}
    if(key == '='){ currentSound = 11; keyPressed('r');}
    
    if(key == 127) {
        circles.clear();
        while (!rectangles.empty()){
            rectangles.pop();
        }
        while (!lines.empty()){
            lines.pop();
        }
        while (!trampolines.empty()){
            trampolines.pop();
        }
        while (streams.size() > 1){
            streams.pop();
        }
    }
    if (key == 's'){
        saveWorld();
    }
    if (key == 'l'){
        strVec file = openDialog();
        if (!file.empty()){
            loadWorld(file[0]);
        }
    }
    //    if (key == 'w'){
    //        currentDrawingMode = 1;
    //        drawingCircles = true;
    //        drawingLines = false;
    //        drawingRectangles = false;
    //        drawingStream = false;
    //        drawingTrampolines = false;
    //    }
    if(key == 'e'){
        currentDrawingMode = 1;
        drawingLines = true;
        drawingCircles = false;
        drawingRectangles = false;
        drawingTrampolines = false;
        drawingStream = false;
    }
    if(key == 'r') {
        currentDrawingMode = 2;
        drawingRectangles = true;
        drawingTrampolines = false;
        drawingLines = false;
        //        drawingCircles = false;
        drawingStream = false;
    }
    if(key == 't'){
        currentDrawingMode = 3;
        drawingTrampolines = true;
        drawingRectangles = false;
        //        drawingCircles = false;
        drawingStream = false;
        drawingLines = false;
    }
    if(key == 'w'){
        currentDrawingMode = 0;
        drawingStream = true;
        drawingCircles = false;
        drawingLines = false;
        drawingRectangles = false;
        drawingTrampolines = false;
    }
    if(key == 9) {
        trickle = !trickle;
    }
    if(key == 'z'){
        if (drawingRectangles && !rectangles.empty()){
            rectangles.pop();
        } else if (drawingLines && !lines.empty()){
            lines.pop();
        } else if (drawingStream && streams.size() > 1){
            streams.pop();
        } else if (drawingTrampolines && !trampolines.empty()){
            trampolines.pop();
        }
    }
    if(key == 'q'){
        circles.clear();
    }
    if(key == 'y'){
        box2d.setTimeStep(0.0f);
        cout << "y pressed" << endl;
    }
    if (key == 'u'){
        box2d.resetTimeStep();
    }
    if(key == 'p'){
        timer = b2Timer();
        trickle = false;
        if (checkPoint){
            for (int i = 0; i < checkData.size(); i++){
                ofVec4f dataPoint = checkData[i];
                shared_ptr <ofxBox2dCircle> c = shared_ptr <ofxBox2dCircle>(new ofxBox2dCircle);
                c.get()->setPhysics(1, 0.5, 0.9);
                c.get()->setup(box2d.getWorld(), dataPoint.x, dataPoint.y, circleRadius);
                c.get()->setVelocity(dataPoint.z, dataPoint.w);
                circles.push_back(c);
            }
        } else {
            stack <b2Vec2> streamsCopy = streams;
            while (!streamsCopy.empty()){
                b2Vec2 coordinates = streamsCopy.top();
                // Create new circle every trickleFrequency
                shared_ptr <ofxBox2dCircle> c = shared_ptr <ofxBox2dCircle>(new ofxBox2dCircle);
                c.get()->setPhysics(1, 0.5, 0.9);
                c.get()->setup(box2d.getWorld(), coordinates.x, coordinates.y, circleRadius);
                circles.push_back(c);
                streamsCopy.pop();
            }
        }
    }
    if(key == 'i'){
        ofVec3f position = myCamera.getPosition();
        //        position.z = position.z + 10;
        //        myCamera.setPosition(position);
        //        width = width * 1.05;
        //        height = height * 1.05;
        //        ofSetupScreenOrtho(width, height);
        //        cout << "newwidth:" << width << endl;
        //        cout << "in" << endl;
        //        cout << "My camera position: " << myCamera.getPosition() << endl;
        ofVec3f cScale = myCamera.getScale();
        //        myCamera.setPosition(currentMouse);
        myCamera.setScale(cScale.x * 1.05, cScale.y * 1.05, cScale.z);
        
        
        
        
    }
    if(key == 'o'){
        ofVec3f position = myCamera.getPosition();
        //        position.z = position.z - 10;
        //        width = width * .95;
        //        height = height * .95;
        //        ofSetupScreenOrtho(width, height);
        //        myCamera.setPosition(position);
        //        cout << "out" << endl;
        //        cout << "My camera position: " << myCamera.getPosition() << endl;
        ofVec3f cScale = myCamera.getScale();
        //        myCamera.setPosition(currentMouse);
        myCamera.setScale(cScale.x * 0.95, cScale.y * 0.95, cScale.z);
        
        //        myCamera.lookAt(ofVec3f(currentMouse));
        
        //        myCamera.setPosition(position.x * 1.05, position.y * 1.05, position.z);
        //        cout << "camera postion" << position.x << "," << position.y << "," << position.z << endl;
        
    }
    if(key == 'j'){
        ofVec3f position = myCamera.getPosition();
        position.x = position.x - 10;
        myCamera.setPosition(position);
        cout << "out" << endl;
        cout << "My camera position: " << myCamera.getPosition() << endl;
    }
    if(key == 'k'){
        ofVec3f position = myCamera.getPosition();
        position.x = position.x + 10;
        myCamera.setPosition(position);
        cout << "out" << endl;
        cout << "My camera position: " << myCamera.getPosition() << endl;
    }
    
    if(key == 'c'){
        checkData.clear();
        for (int i = 0; i < circles.size(); i++){
            shared_ptr<ofxBox2dCircle> circleToSave = circles[i];
            ofVec4f data = ofVec4f(circleToSave.get()->getPosition().x, circleToSave.get()->getPosition().y, circleToSave.get()->getVelocity().x, circleToSave.get()->getVelocity().y );
            checkData.push_back(data);
        }
        checkPoint = true;
        keyPressed('q');
    }
    
}
