//
//  keyPresses.cpp
//  collide
//
//  Created by Andrew Lee on 11/15/15.
//
//

#include "keyPresses.hpp"
#include "ofxFileDialog.h"
#include "b2dJson.h"


const int COMMAND_KEY = 4352;
const int FN_KEY = -1;
const int SHIFT_KEY = 2304;
const int DELETE_KEY = 127;
const int TAB_KEY = 9;
const int TILDA_KEY = 96;

const int PIANO_LOWEST = 4;
const int PIANO_HIGHEST = 63;

keyPresses::keyPresses(testApp* ptr)
{
    myApp = ptr;
}

void keyPresses::clearBallTrajectories(){
    for (int i = 0; i < myApp->ballTrajectories.size(); i++){
        myApp->ballTrajectories[i].clear();
    }
//    myApp->ballTrajectories.clear();
//    while (myApp->ballTrajectories.size() > myApp->circles.size()){
//        myApp->ballTrajectories.pop_back();
//    }
//    while (myApp->ballTrajectories.size() < myApp->circles.size()){
//        vector<b2Vec2> newPath;
//        myApp->ballTrajectories.push_back(newPath);
//    }
//    for (int i = 0; i < myApp->ballTrajectories.size(); i++){
//        myApp->ballTrajectories[i].clear();
//    }
}

void keyPresses::keyReleased(int key) {
    if (key == SHIFT_KEY) myApp->shiftIsDown = false;
    if (key == COMMAND_KEY) myApp->commandIsDown = false;
    if (key == FN_KEY) myApp->fnIsDown = false;
}

void keyPresses::keyPressed(int key){
    if (myApp->currentMode == SELECTION){
        switch (myApp->selected.mode){
            case RECTANGLE:
            case TRAMPOLINE:{
                shared_ptr<ofxBox2dBaseShape> object = myApp->selected.ptr;
                int sound = object.get()->body->getSoundFile();
                if(key == '1'){ sound = myApp->START_NOTE + 0; }
                if(key == '2'){ sound = myApp->START_NOTE + 1; }
                if(key == '3'){ sound = myApp->START_NOTE + 2; }
                if(key == '4'){ sound = myApp->START_NOTE + 3; }
                if(key == '5'){ sound = myApp->START_NOTE + 4; }
                if(key == '6'){ sound = myApp->START_NOTE + 5; }
                if(key == '7'){ sound = myApp->START_NOTE + 6; }
                if(key == '8'){ sound = myApp->START_NOTE + 7; }
                if(key == '9'){ sound = myApp->START_NOTE + 8; }
                if(key == '0'){ sound = myApp->START_NOTE + 9; }
                if(key == '-'){ sound = myApp->START_NOTE + 10; }
                if(key == '='){ sound = myApp->START_NOTE + 11; }
                
                //
                if(key == 'c'){ sound = myApp->START_NOTE + 0; }
                if(key == 'd'){ sound = myApp->START_NOTE + 2; }
                if(key == 'e'){ sound = myApp->START_NOTE + 4; }
                if(key == 'f'){ sound = myApp->START_NOTE + 5; }
                if(key == 'g'){ sound = myApp->START_NOTE + 7; }
                if(key == 'a'){ sound = myApp->START_NOTE + 9; }
                if(key == 'b'){ sound = myApp->START_NOTE + 11;}
                if(key == 'x' && sound < 52){
                    if (sound < 52) sound = sound+12;
                }
                if(key == 'z' && sound > PIANO_LOWEST){
                    if (sound > 15) sound = sound-12;
                }
                if (key == COMMAND_KEY && sound > PIANO_LOWEST) sound--;
                if (key == SHIFT_KEY && sound < PIANO_HIGHEST){
                    sound++;
                }
                
                object.get()->body->setSoundFile(sound);
//                return;
                break;
                
            }
            case PORTAL_IN:{
                b2Vec2 coord = myApp->selected.coordinates;
                for (int i = 0; i < myApp->inPortals.size(); i++){
                    if (myApp->inPortals[i].coordinates == coord){
                        int newPairNumber = myApp->inPortals[i].pairNumber;
                        if(key == '1'){ newPairNumber = 1; }
                        if(key == '2'){ newPairNumber = 2; }
                        if(key == '3'){ newPairNumber = 3; }
                        if(key == '4'){ newPairNumber = 4; }
                        if(key == '5'){ newPairNumber = 5; }
                        if(key == '6'){ newPairNumber = 6; }
                        if(key == '7'){ newPairNumber = 7; }
                        if(key == '8'){ newPairNumber = 8; }
                        if(key == '9'){ newPairNumber = 9; }
                        if(key == '0'){ newPairNumber = 10; }
                        if(key == '-'){ newPairNumber = 11; }
                        if(key == '='){ newPairNumber = 12; }
                        myApp->inPortals[i].pairNumber = newPairNumber;
                        break;
                    }
                }
                break;
            }
            case PORTAL_OUT:{
                b2Vec2 coord = myApp->selected.coordinates;
                for (int i = 0; i < myApp->outPortals.size(); i++){
                    if (myApp->outPortals[i].coordinates == coord){
                        int newPairNumber = myApp->outPortals[i].pairNumber;
                        if(key == '1'){ newPairNumber = 1; }
                        if(key == '2'){ newPairNumber = 2; }
                        if(key == '3'){ newPairNumber = 3; }
                        if(key == '4'){ newPairNumber = 4; }
                        if(key == '5'){ newPairNumber = 5; }
                        if(key == '6'){ newPairNumber = 6; }
                        if(key == '7'){ newPairNumber = 7; }
                        if(key == '8'){ newPairNumber = 8; }
                        if(key == '9'){ newPairNumber = 9; }
                        if(key == '0'){ newPairNumber = 10; }
                        if(key == '-'){ newPairNumber = 11; }
                        if(key == '='){ newPairNumber = 12; }
                        myApp->outPortals[i].pairNumber = newPairNumber;
                        break;
                    }
                }
                break;
            }
                
            default:
                break;
        }
    } else {
        if(key == '1'){ myApp->currentSound = myApp->START_NOTE + 0; keyPressed('r');}
        if(key == '2'){ myApp->currentSound = myApp->START_NOTE + 1; keyPressed('r');}
        if(key == '3'){ myApp->currentSound = myApp->START_NOTE + 2; keyPressed('r');}
        if(key == '4'){ myApp->currentSound = myApp->START_NOTE + 3; keyPressed('r');}
        if(key == '5'){ myApp->currentSound = myApp->START_NOTE + 4; keyPressed('r');}
        if(key == '6'){ myApp->currentSound = myApp->START_NOTE + 5; keyPressed('r');}
        if(key == '7'){ myApp->currentSound = myApp->START_NOTE + 6; keyPressed('r');}
        if(key == '8'){ myApp->currentSound = myApp->START_NOTE + 7; keyPressed('r');}
        if(key == '9'){ myApp->currentSound = myApp->START_NOTE + 8; keyPressed('r');}
        if(key == '0'){ myApp->currentSound = myApp->START_NOTE + 9; keyPressed('r');}
        if(key == '-'){ myApp->currentSound = myApp->START_NOTE + 10; keyPressed('r');}
        if(key == '='){ myApp->currentSound = myApp->START_NOTE + 11; keyPressed('r');}
        
        
        if(key == 'c'){ myApp->currentSound = myApp->START_NOTE + 0; keyPressed('r');}
        if(key == 'd'){ myApp->currentSound = myApp->START_NOTE + 2; keyPressed('r');}
        if(key == 'e'){ myApp->currentSound = myApp->START_NOTE + 4; keyPressed('r');}
        if(key == 'f'){ myApp->currentSound = myApp->START_NOTE + 5; keyPressed('r');}
        if(key == 'g'){ myApp->currentSound = myApp->START_NOTE + 7; keyPressed('r');}
        if(key == 'a'){ myApp->currentSound = myApp->START_NOTE + 9; keyPressed('r');}
        if(key == 'b'){ myApp->currentSound = myApp->START_NOTE + 11; keyPressed('r');}
        
        if(key == 'x' && myApp->START_NOTE < 52){
            myApp->START_NOTE = myApp->START_NOTE + 12;
            if (myApp->currentSound < 52) myApp->currentSound = myApp->currentSound+12;
        }
        if(key == 'z' && myApp->START_NOTE > PIANO_LOWEST){
            myApp->START_NOTE = myApp->START_NOTE - 12;
            if (myApp->currentSound > 15) myApp->currentSound = myApp->currentSound-12;
        }
    }

    
    if(key == TILDA_KEY){ myApp->circles.clear(); clearBallTrajectories(); }
    if(key == 'q' && !myApp->currentlyDrawingRectangle){
        myApp->currentMode = LINE;
        myApp->currentLine.clear();
        ofShowCursor();
    }
    if(key == 'w' && !myApp->currentlyDrawingRectangle) {
        myApp->currentMode = STREAM;
        ofShowCursor();
    }
    if(key == 'r' && !myApp->currentlyDrawingRectangle){
        myApp->currentMode = RECTANGLE;
        myApp->rotatingRectangles = false;
        ofShowCursor();
    }
    if(key == 'R'){
        myApp->currentMode = RECTANGLE;
        myApp->rotatingRectangles = true;
        ofShowCursor();
        if (myApp->currentSound > PIANO_LOWEST) {
            myApp->currentSound = myApp->currentSound - 1;
            myApp->START_NOTE = PIANO_LOWEST + (12 * ((myApp->currentSound - PIANO_LOWEST) / 12));
        }
    }
    if(key == 't' && !myApp->currentlyDrawingRectangle){
        myApp->currentMode = TRAMPOLINE;
        myApp->rotatingRectangles = false;
        ofShowCursor();
    }
    if(key == 'T' && !myApp->currentlyDrawingRectangle){
        myApp->currentMode = TRAMPOLINE;
        myApp->rotatingRectangles = true;
        ofShowCursor();
        if (myApp->currentSound > PIANO_LOWEST) {
            myApp->currentSound = myApp->currentSound - 1;
            myApp->START_NOTE = PIANO_LOWEST + (12 * ((myApp->currentSound - PIANO_LOWEST) / 12));
        }
    }
    if(key == 'y' && !myApp->currentlyDrawingRectangle){
        myApp->currentMode = PORTAL_IN;
        ofHideCursor();
    }
    if(key == 'u' && !myApp->currentlyDrawingRectangle){
        myApp->currentMode = PORTAL_OUT;
        ofHideCursor();
    }
    if(key == 'i'){
        ofVec3f position = myApp->myCamera.getPosition();
        ofVec3f cScale = myApp->myCamera.getScale();
        myApp->myCamera.setScale(cScale.x * 0.95, cScale.y * 0.95, cScale.z);
    }
    if(key == 'o'){
        ofVec3f position = myApp->myCamera.getPosition();
        ofVec3f cScale = myApp->myCamera.getScale();
        myApp->myCamera.setScale(cScale.x * 1.05, cScale.y * 1.05, cScale.z);
    }
    if(key == 'p'){ // main PLAY button
        if (myApp->fnIsDown){
            if (myApp->circles.size() > 0){
                myApp->paused = true;
                myApp->box2d.setTimeStep(0);
            }
        } else {
            myApp->box2d.resetTimeStep();
            if (myApp->paused){
                // Un-pause
                myApp->paused = false;
            } else {
                myApp->paused = false;
                
                // Actual 'p', start new play back
                
                myApp->deleteOffScreen();
                
                clearBallTrajectories();
                
                // Set all ROTATING platforms back to original position
                for (platform p : myApp->trampolines){
                    if (p.rotating){
                        b2Transform transform = p.ptr->body->GetTransform();
                        b2Vec2 position = transform.p;
                        float angle = p.startingAngle;
                        p.ptr->body->SetTransform(p.ptr->body->GetPosition(), angle);
                    }
                }
                for (platform p : myApp->rectangles){
                    if (p.rotating){
                        b2Transform transform = p.ptr->body->GetTransform();
                        b2Vec2 position = transform.p;
                        float angle = p.startingAngle;
                        p.ptr->body->SetTransform(p.ptr->body->GetPosition(), angle);
                    }
                }
                
                
                myApp->timer = b2Timer();
                myApp->trickle = false;
                if (myApp->checkPoint){
                    myApp->circles.clear();
                    
//                    // CHECKPOINT, bodydef and checkpointData attempt
//                    for (b2BodyDef b : myApp->checkpointData){
//                        cout << "bodyDef b" << endl;
//                        shared_ptr <ofxBox2dCircle> c = shared_ptr <ofxBox2dCircle>(new ofxBox2dCircle);
//                        c.get()->setPhysics(1, 0.5, 0.9);
//                        c.get()->setup(myApp->box2d.getWorld(), b);
//                        myApp->circles.push_back(c);
//                    }
                    
                    // CHECKPOINT, recreating circles from saved data attempt
                    for (int i = 0; i < myApp->checkData.size(); i++){
                        //Populating circles with check point data
                        ofVec4f dataPoint = myApp->checkData[i];
                        shared_ptr <ofxBox2dCircle> c = shared_ptr <ofxBox2dCircle>(new ofxBox2dCircle);
                        c.get()->setPhysics(1, 0.5, 0.9);
                        c.get()->setup(myApp->box2d.getWorld(), dataPoint.x, dataPoint.y, myApp->CIRCLE_RADIUS);
                        ofVec2f velocity = ofVec2f(dataPoint.z, dataPoint.w);
//                        c.get()->setVelocity(dataPoint.z, dataPoint.w);
                        c.get()->setVelocity(velocity);
                        float angularVelocity = myApp->checkData2[i];
                        c.get()->body->SetAngularVelocity(angularVelocity);
                        c.get()->setCircleID(myApp->circleIDCounter);
                        myApp->circleIDCounter++;
//                        vector<b2Vec2> newPath;
//                        myApp->ballTrajectories.push_back(newPath);
                        myApp->circles.push_back(c);
                    }
                    // set rotating platforms angles
                    for (int i = 0; i < myApp->rectangles.size(); i++){
                        platform p = myApp->rectangles[i];
                        if (p.rotating){
                            float angle = myApp->checkPointRec[i];
                            p.ptr->body->SetTransform(p.ptr->body->GetPosition(), angle);
                        }
                    }
                    for (int i = 0; i < myApp->trampolines.size(); i++){
                        platform p = myApp->trampolines[i];
                        if (p.rotating){
                            float angle = myApp->checkPointTramp[i];
                            p.ptr->body->SetTransform(p.ptr->body->GetPosition(), angle);
                        }
                    }

//
                    // CHECKPOINT, recreating from json string attempt
//                    string errorMsg;
//                    b2World* myWorld = myApp->json.readFromString(myApp->jsonData, errorMsg);
//                    cout << "reading from world" << endl;
//                    
////                    myApp->box2d.init(myWorld);
//                    myApp->box2d.setWorld(myWorld);
//
//                    myApp->box2d.enableEvents();   // <-- turn on the event listener
//                    myApp->box2d.setGravity(0, 5); // turned it negative after camera thing
//                    myApp->box2d.setFPS(60.0);
//                    myApp->box2d.registerGrabbing();
//                    
                    
                } else {
                    
                    // Create new circle from every stream
                    for (int i = 0; i < myApp->streams.size(); i++){
                        b2Vec2 coordinates = myApp->streams[i];
                        shared_ptr <ofxBox2dCircle> c = shared_ptr <ofxBox2dCircle>(new ofxBox2dCircle);
                        c.get()->setPhysics(1, 0.5, 0.9);
                        c.get()->setup(myApp->box2d.getWorld(), coordinates.x, coordinates.y, myApp->CIRCLE_RADIUS);
                        c.get()->setCircleID(myApp->circleIDCounter);
                        myApp->circleIDCounter++;
                        vector<b2Vec2> newPath;
                        myApp->ballTrajectories.push_back(newPath);
                        myApp->circles.push_back(c);
                    }
                }
            }
        }
    }
    if(key == 'v'){
        ofHideCursor();
        myApp->currentMode = SELECTION;
    }
    if (key == TAB_KEY) myApp->trickle = !myApp->trickle;
    if (key == SHIFT_KEY){
        myApp->shiftIsDown = true;
        if (myApp->currentSound < PIANO_HIGHEST){
            myApp->currentSound = myApp->currentSound + 1;
            myApp->START_NOTE = PIANO_LOWEST + (12 * ((myApp->currentSound - PIANO_LOWEST) / 12));
        }
    }
    if (key == COMMAND_KEY){
        myApp->commandIsDown = true;
        if (myApp->currentSound > PIANO_LOWEST) {
            myApp->currentSound = myApp->currentSound - 1;
            myApp->START_NOTE = PIANO_LOWEST + (12 * ((myApp->currentSound - PIANO_LOWEST) / 12));
        }
    }
    if (key == FN_KEY){
        myApp->fnIsDown = true;
    }
    if (key == DELETE_KEY){
        if (myApp->currentMode == SELECTION){
            switch(myApp->selected.mode){
                case RECTANGLE:{
                    int selectedID = myApp->selected.id;
                    myApp->rectangles.erase(std::remove_if(myApp->rectangles.begin(), myApp->rectangles.end(), [selectedID](platform& p) { return p.id == selectedID; }), myApp->rectangles.end());
//                    myApp->rectangles.erase(std::remove(myApp->rectangles.begin(), myApp->rectangles.end(), myApp->selected.ptr), myApp->rectangles.end());
                    myApp->selected.mode = SELECTION;
                    myApp->selected.ptr->destroy();
                    break;
                }
                case TRAMPOLINE:{
                    int selectedID = myApp->selected.id;
                    myApp->trampolines.erase(std::remove_if(myApp->trampolines.begin(), myApp->trampolines.end(), [selectedID](platform& p) { return p.id == selectedID; }), myApp->trampolines.end());
                    //                    myApp->trampolines.erase(std::remove(myApp->trampolines.begin(), myApp->trampolines.end(), myApp->selected.ptr), myApp->trampolines.end());
                    myApp->selected.mode = SELECTION;
                    myApp->selected.ptr->destroy();
                    break;
                }
                case LINE:
                    myApp->lines.erase(std::remove(myApp->lines.begin(), myApp->lines.end(), myApp->selected.ptr), myApp->lines.end());
                    myApp->selected.mode = SELECTION;
                    myApp->selected.ptr->destroy();
                    break;
                case PORTAL_IN:{
                    b2Vec2 selectedCoordinates = b2Vec2(myApp->selected.coordinates);
                    myApp->inPortals.erase(std::remove_if(myApp->inPortals.begin(), myApp->inPortals.end(), [selectedCoordinates](portal& p) { return p.coordinates == selectedCoordinates; }), myApp->inPortals.end());
                    myApp->selected.mode = SELECTION;
                    break;
                }
                case PORTAL_OUT:{
                    b2Vec2 selectedCoordinates = b2Vec2(myApp->selected.coordinates);
                    myApp->outPortals.erase(std::remove_if(myApp->outPortals.begin(), myApp->outPortals.end(), [selectedCoordinates](portal& p) { return p.coordinates == selectedCoordinates; }), myApp->outPortals.end());
                    myApp->selected.mode = SELECTION;
                    break;
                }
                case STREAM:
                    myApp->streams.erase(std::remove(myApp->streams.begin(), myApp->streams.end(), myApp->selected.coordinates), myApp->streams.end());
                    myApp->selected.mode = SELECTION;
                    break;
                default:
                    break;
            }
        } else {
            myApp->circles.clear();
        }
    }
    
    if(key == 8) { // FN + DELETE
        keyPressed('k');
//        myApp->currentSound = myApp->currentSound + 1;
//        myApp->START_NOTE = 16 + (12 * ((myApp->currentSound - 16) / 12));
        myApp->circles.clear();
        clearBallTrajectories();
        myApp->rectangles.clear();
        myApp->lines.clear();
        myApp->trampolines.clear();
        myApp->inPortals.clear();
        myApp->outPortals.clear();
        while (myApp->streams.size() > 1){
            myApp->streams.pop_back();
        }
        myApp->currentMode = RECTANGLE;
        
        //clear checkPoint
        myApp->checkPointRec.clear();
        myApp->checkPointTramp.clear();
        myApp->checkData.clear();
        myApp->checkData2.clear();
    }
    if(key == 'z' && myApp->fnIsDown){
        if (myApp->currentSound < 52) myApp->currentSound = myApp->currentSound+12;
        if (myApp->START_NOTE < 52) myApp->START_NOTE = myApp->START_NOTE + 12;

//        myApp->currentSound = myApp->currentSound + 1;
//        myApp->START_NOTE = 16 + (12 * ((myApp->currentSound - 16) / 12));
        switch(myApp->currentMode){
            case RECTANGLE:
                if (!myApp->rectangles.empty()){
                    myApp->rectangles.pop_back();
                }
                if (!myApp->checkPointRec.empty()){
                    myApp->checkPointRec.pop_back();
                }
                break;
            case LINE:
                if (!myApp->lines.empty()){
                    myApp->lines.pop_back();
                }
                break;
            case STREAM:
                if (myApp->streams.size() > 1){
                    myApp->streams.pop_back();
                }
                break;
            case TRAMPOLINE:
                if (!myApp->trampolines.empty()){
                    myApp->trampolines.pop_back();
                }
                if (!myApp->checkPointTramp.empty()){
                    myApp->checkPointTramp.pop_back();
                }
                break;
            case PORTAL_IN:
                if (!myApp->inPortals.empty()){
                    myApp->inPortals.pop_back();
                }
                break;
            case PORTAL_OUT:
                if (!myApp->outPortals.empty()){
                    myApp->outPortals.pop_back();
                }
                break;
            default:
                break;
        }
    }
    
    if (key == 's'){
        myApp->saveWorld();
    }
    if (key == 'l'){
        myApp->circles.clear();
        keyPressed('k');
        clearBallTrajectories();
        strVec file = openDialog();
        if (!file.empty()){
            myApp->loadWorld(file[0]);
        }
    }
    if (key == 'h'){
        myApp->showInstructions = !myApp->showInstructions;
    }
    if (key == 'n'){
        myApp->showBallTrajectories = !myApp->showBallTrajectories;
    }
    if (key == 'j'){
        myApp->deleteOffScreen();
        if (myApp->circles.size() <= 0){
            keyPressed('k');
            return;
        }
        
        myApp->jsonData = myApp->json.writeToString(myApp->box2d.world);

//        // trying to copy over bodydef
//        myApp->checkpointData.clear();
//        for (int i = 0; i < myApp->circles.size(); i++){
//            b2BodyDef d = myApp->circles[i].get()->bodyDef;
////            b2Body* c = myApp->box2d.world->CreateBody(&d);
//            myApp->checkpointData.push_back(d);
//        }
//        myApp->checkPoint = true;
        
        myApp->checkData.clear();
        myApp->checkData2.clear();
        for (int i = 0; i < myApp->circles.size(); i++){
            shared_ptr<ofxBox2dCircle> circleToSave = myApp->circles[i];
            myApp->checkData2.push_back(circleToSave.get()->body->GetAngularVelocity());
//            cout << ".get()->body->getPosition:" << circleToSave.get()->body->GetPosition().x << "," << circleToSave.get()->body->GetPosition().y << endl;
            ofVec4f data = ofVec4f(circleToSave.get()->getPosition().x, circleToSave.get()->getPosition().y, circleToSave.get()->getVelocity().x, circleToSave.get()->getVelocity().y );
            myApp->checkData.push_back(data);
        }
        
        // PLATFORM ROTATING ANGLES
        myApp->checkPointRec.clear();
        int sizeRec = myApp->rectangles.size();
        vector<float> recs(sizeRec);
        myApp->checkPointRec = recs;
        myApp->checkPointTramp.clear();

        int sizeTramp = myApp->trampolines.size();
        vector<float> tramps(sizeTramp);
        myApp->checkPointTramp = tramps;
        for (int i = 0; i < myApp->rectangles.size(); i++){
            platform p = myApp->rectangles[i];
            if (p.rotating){
                b2Transform transform = p.ptr->body->GetTransform();
                b2Vec2 position = transform.p;
                float angle = transform.q.GetAngle();
                myApp->checkPointRec[i] = angle;
            }
        }
        for (int i = 0; i < myApp->trampolines.size(); i++){
            platform p = myApp->trampolines[i];
            if (p.rotating){
                b2Transform transform = p.ptr->body->GetTransform();
                b2Vec2 position = transform.p;
                float angle = transform.q.GetAngle();
                myApp->checkPointTramp[i] = angle;
            }
            
        }

        
        myApp->checkPoint = true;
    }
    if (key == 'k'){
        myApp->checkPoint = false;
        myApp->checkData.clear();
        myApp->checkData2.clear();
//        myApp->checkpointData.clear();  //bodydef attempt
        myApp->circles.clear();
    }
    if (key == 'm'){
        if (myApp->instructionMode == BEGINNER) myApp->instructionMode = ADVANCED;
        else if (myApp->instructionMode == ADVANCED) myApp->instructionMode = BEGINNER;
    }



}
