//
//  mouse.cpp
//  collide
//
//  Created by Andrew Lee on 11/30/15.
//
//

#include "mouse.h"

mouse::mouse(testApp* ptr)
{
    myApp = ptr;
}

void mouse::mouseMoved(int x, int y){
    myApp->mousePos = ofVec2f(x, y);
    switch(myApp->currentMode){
        case SELECTION:
        case PORTAL_IN:
        case PORTAL_OUT:
            ofHideCursor();
            break;
        default:
            ofShowCursor();
    }
}
void mouse::mouseDragged(int screen_x, int screen_y, int button){
    myApp->mousePos = ofVec2f(screen_x, screen_y);
    ofVec3f worldCoord = myApp->myCamera.screenToWorld(ofVec3f(screen_x, screen_y, 0));
    int x = worldCoord.x;
    int y = worldCoord.y;
    
    myApp->recPoint2 = b2Vec2(x, y);
    switch(myApp->currentMode){
        case SELECTION:
        {
            if (myApp->selected.dragged){
                switch (myApp->selected.mode){
                        
                    // DRAGGING STUFF TO REPOSITION
                    case LINE:{
                        
                        // TODO:
                        // right now it does nothing
                        // eventually if I save the right ptr, I can create new lines offset at each vertex by the difference
                        
//                        ofVec2f difference = myApp->selected.difference;
//                        
//                        // I have a box2dedge selected. i should delete it and create a new one
//                        // with vertices
////                        myApp->selected.ptr.get(). // delete the line
//                        
//                        
////                        myApp->currentLine.clear();
//                        // add in vertices
//                        ofPoint p1;
////                        myApp->selected.ptr.get()->destroy();
//                        
//                        // CAN'T CONVERT BETWEEN ofPtr<ofxBox2dEdge> and shared_ptr<basedShape>
//                        
//                        ofPtr<ofxBox2dEdge> linePtr = myApp->lines[i];
//                        int N = linePtr.get()->size();
//                        p1 = (*linePtr.get())[0];
//                        
//            
//                        
//                        
//                        
//                        
//                        // this to the end is the process for taking current line and creating a new line that gets saved
//                        myApp->currentlyDrawingLine = true;
//                        myApp->currentLine.setClosed(false);
//                        myApp->currentLine.simplify();
//                        if (myApp->currentLine.getPerimeter() < myApp-> MIN_LINE_LENGTH){
//                            myApp->currentLine.clear();
//                            break;
//                        }
//                        shared_ptr <ofxBox2dEdge> line = shared_ptr <ofxBox2dEdge>(new ofxBox2dEdge);
//                        line.get()->addVertexes(myApp->currentLine);
//                        line.get()->addVertex(x, y);
//                        line.get()->setPhysics(0.0, 0.5, 0.5);
//                        line->create(myApp->box2d.getWorld());
//                        myApp->lines.push_back(line);
//                        myApp->currentLine.clear();
            
                        break;
                    }
                    case RECTANGLE:
                    case TRAMPOLINE:{
                        ofVec2f difference = myApp->selected.difference;
                        myApp->selected.ptr->setPosition(x + difference.x, y + difference.y);
                        break;
                    }
                    case PORTAL_IN:
                    case PORTAL_OUT:
                    case STREAM:{
                        ofVec2f diff = myApp->selected.difference;
                        myApp->selected.intermittent = b2Vec2(x + diff.x, y + diff.y);
                        myApp->selected.coordinates = b2Vec2(x + diff.x, y + diff.y);
                    }
                    default:
                        break;
                }
            } else {
                
                // DRAG the SCREEN
                b2Vec2 vector = b2Vec2(myApp->recPoint2.x - myApp->recPoint1.x, myApp->recPoint2.y - myApp->recPoint1.y);
                ofVec3f original = ofVec3f(myApp->myCamera.getPosition());
                original.x = original.x - vector.x;
                original.y = original.y - vector.y;
                myApp->myCamera.setPosition(original);
            }
            break;
        }
        case LINE:
            if (myApp->currentlyDrawingLine){
                myApp->currentLine.addVertex(x, y);
            }
            break;
        case RECTANGLE:
        case TRAMPOLINE:{
        
            b2Vec2 toTarget = myApp->recPoint2 - myApp->recPoint1;
            float desiredAngle = atan2f(toTarget.y, toTarget.x);
            float hypotenuse = sqrt(pow(toTarget.x, 2) + pow(toTarget.y, 2));
//            if (myApp->shiftIsDown){
            if (myApp->fnIsDown){

//                cout << "desiredAngle" << desiredAngle / (PI / 4) << endl;
//                cout << "roundedAngle" << floor(desiredAngle / (PI / 4) + 0.5) << endl;
                desiredAngle = floor(desiredAngle / (PI / 4)) * (PI / 4);
                float offsetX = cos(desiredAngle) * hypotenuse;
                float offsetY = sin(desiredAngle) * hypotenuse;
                b2Vec2 newRecPoint2 = b2Vec2(myApp->recPoint1.x + offsetX, myApp->recPoint1.y + offsetY);
//                myApp->recPoint2.x = myApp->recPoint1.x + offsetX;
//                myApp->recPoint2.y = myApp->recPoint2.y + offsetY;
                b2Vec2 newTarget = newRecPoint2 - myApp->recPoint1;
                float newAngle = atan2f(newTarget.y, newTarget.x);
                float newHypotenuse = sqrt(pow(newTarget.x, 2) + pow(newTarget.y, 2));
                
                myApp->currentRectangle.x = (myApp->recPoint1.x + newRecPoint2.x) / 2;
                myApp->currentRectangle.y = (myApp->recPoint1.y + newRecPoint2.y) / 2;
                myApp->currentRectangle.w = newHypotenuse;
                myApp->currentRectangle.h = myApp->RECTANGLE_WIDTH;
                myApp->currentRectangle.angle = newAngle;
//                myApp->currentRectangle.setup(myApp->box2d.getWorld(), (myApp->recPoint1.x + newRecPoint2.x) / 2, (myApp->recPoint1.y + newRecPoint2.y) / 2, newHypotenuse, myApp->RECTANGLE_WIDTH);
//                b2Body* rectBody = myApp->currentRectangle.body;
//                rectBody->SetTransform(rectBody->GetPosition(), newAngle);
            } else {
                myApp->currentRectangle.x = (myApp->recPoint1.x + myApp->recPoint2.x) / 2;
                myApp->currentRectangle.y = (myApp->recPoint1.y + myApp->recPoint2.y) / 2;
                myApp->currentRectangle.w = hypotenuse;
                myApp->currentRectangle.h = myApp->RECTANGLE_WIDTH;
                myApp->currentRectangle.angle = desiredAngle;
//                myApp->currentRectangle.setup(myApp->box2d.getWorld(), (myApp->recPoint1.x + myApp->recPoint2.x) / 2, (myApp->recPoint1.y + myApp->recPoint2.y) / 2, hypotenuse, myApp->RECTANGLE_WIDTH);
//                b2Body* rectBody = myApp->currentRectangle.body;
//                rectBody->SetTransform(rectBody->GetPosition(), desiredAngle);
            }
        }
        default:
            break;
    }
}

void mouse::mousePressed(int screen_x, int screen_y, int button){
//    cout << "mousePress.x: " << screen_x << ", mousePress.y: " << screen_y << endl;
    
    // IF WITHIN BUTTONS, don't do anything else
    for (int i = 0; i < myApp->NUM_BUTTONS; i++){
        if (myApp->buttons[i].isInside(screen_x, screen_y)){
            myApp->justPressedButton = true;
            return;
        }
    }
    
    
    ofVec3f worldCoord = myApp->myCamera.screenToWorld(ofVec3f(screen_x, screen_y, 0));
    int x = worldCoord.x;
    int y = worldCoord.y;
    
//    cout << "mouseWorld.x: " << x << ", mouseWorld.y: " << y << endl;

    
    // Saving cursor point + current Rectangle
    myApp->recPoint1 = b2Vec2(x, y);
    myApp->recPoint2 = b2Vec2(x, y);
    myApp->currentRectangle.x = x;
    myApp->currentRectangle.y = y;
    myApp->currentRectangle.w = 0;
    myApp->currentRectangle.h = 0;
    
    switch(myApp->currentMode){
        case PORTAL_IN:{
            portal p;
            p.coordinates = b2Vec2(x, y);
            p.pairNumber = myApp->inPortals.size() + 1;
            p.angle = ((float)rand() / RAND_MAX) * 2 * PI;
            myApp->inPortals.push_back(p);
            break;
        }
        case PORTAL_OUT:{
            portal p;
            p.coordinates = b2Vec2(x, y);
            p.pairNumber = myApp->outPortals.size() + 1;
            p.angle = ((float)rand() / RAND_MAX) * 2 * PI;
            myApp->outPortals.push_back(p);
            break;
        }
        case LINE:
            myApp->currentLine.clear();
            myApp->currentLine.addVertex(x, y);
            myApp->currentlyDrawingLine = true;
            break;
        case STREAM:
            myApp->streams.push_back(b2Vec2(x, y));
            break;
        case RECTANGLE:
        case TRAMPOLINE:
            myApp->currentlyDrawingRectangle = true;
            break;
        case SELECTION:
            if (myApp->detectSelection(x, y)){
                myApp->selected.dragged = true;
                ofVec2f pos;
                switch (myApp->selected.mode){
                    case RECTANGLE:
                    case TRAMPOLINE:
                    case LINE:
                        pos = myApp->selected.ptr->getPosition();
                        break;
                    case PORTAL_OUT:
                        pos = ofVec2f(myApp->selected.coordinates.x, myApp->selected.coordinates.y);
                        myApp->outPortals.erase(std::remove_if(myApp->outPortals.begin(), myApp->outPortals.end(), [pos](portal& p) { return p.coordinates == b2Vec2(pos.x, pos.y); }), myApp->outPortals.end());
                        break;
                    case PORTAL_IN:
                        pos = ofVec2f(myApp->selected.coordinates.x, myApp->selected.coordinates.y);
                        myApp->inPortals.erase(std::remove_if(myApp->inPortals.begin(), myApp->inPortals.end(), [pos](portal& p) { return p.coordinates == b2Vec2(pos.x, pos.y); }), myApp->inPortals.end());
                    case STREAM:
                        pos = ofVec2f(myApp->selected.coordinates.x, myApp->selected.coordinates.y);
                        myApp->streams.erase(std::remove_if(myApp->streams.begin(), myApp->streams.end(), [pos](b2Vec2& s) { return s == b2Vec2(pos.x, pos.y); }), myApp->streams.end());
                        break;
                    default:
                        break;
                }
                myApp->selected.difference = ofVec2f(pos.x - x, pos.y - y);
            } else {
                myApp->mouseIsDown = true;
            }
        default:
            break;
    }
}
void mouse::mouseReleased(int screen_x, int screen_y, int button){
    if (myApp->justPressedButton){
        myApp->justPressedButton = false;
        return;
    }
    
    myApp->mouseIsDown = false;
    myApp->currentlyDrawingRectangle = false;
    ofVec3f worldCoord = myApp->myCamera.screenToWorld(ofVec3f(screen_x, screen_y, 0));
    int x = worldCoord.x;
    int y = worldCoord.y;
    
    switch(myApp->currentMode){
        case LINE: // CREATING NEW LINE
        {
            myApp->currentlyDrawingLine = false;

            myApp->currentLine.setClosed(false);
            myApp->currentLine.simplify();
            
            if (myApp->currentLine.getPerimeter() < myApp-> MIN_LINE_LENGTH){
                myApp->currentLine.clear();
                break;
            }
            shared_ptr <ofxBox2dEdge> line = shared_ptr <ofxBox2dEdge>(new ofxBox2dEdge);
            
            line.get()->addVertexes(myApp->currentLine);
            line.get()->addVertex(x, y);
            line.get()->setPhysics(0.0, 0.5, 0.5);
            line->create(myApp->box2d.getWorld());
            myApp->lines.push_back(line);
            
            myApp->currentLine.clear();
            break;
        }
        case RECTANGLE:
        case TRAMPOLINE:
        {
            
            // make a shared_ptr, not a local
            
            // Set to current rectangle
            if (myApp->currentRectangle.w < myApp->MIN_RECT_LENGTH)break;
            shared_ptr<ofxBox2dRect> rect = shared_ptr<ofxBox2dRect>(new ofxBox2dRect);
            rect.get()->setPhysics(0,0.2,0.2);
            ofVec2f pos = ofVec2f(myApp->currentRectangle.x, myApp->currentRectangle.y);
            float w = myApp->currentRectangle.w;
            float h = myApp->currentRectangle.h;
            rect.get()->setup(myApp->box2d.getWorld(), pos.x, pos.y, w, h);
            rect.get()->body->SetType(b2_staticBody);
            b2Body* rectBody = rect.get()->body;
            rectBody->SetTransform(rectBody->GetPosition(), myApp->currentRectangle.angle);
            rectBody->setSoundFile(myApp->currentSound);
            if (myApp->currentMode == TRAMPOLINE){
                rectBody->setAcceleration(myApp->TRAMPOLINE_ACCEL);
                platform newPlatform;
                newPlatform.ptr = rect;
                newPlatform.id = myApp->idCounter;
                newPlatform.startingAngle = myApp->currentRectangle.angle;
                newPlatform.timesBeforeExpire = 0;
                if (myApp->rotatingRectangles){
                    newPlatform.rotating = true;
                } else {
                    newPlatform.rotating = false;
                }
                myApp->idCounter = myApp->idCounter + 1;
                myApp->trampolines.push_back(newPlatform);

                /// also add to checkpoint data
                b2Transform transform = newPlatform.ptr->body->GetTransform();
                b2Vec2 position = transform.p;
                float angle = transform.q.GetAngle();
                myApp->checkPointTramp.push_back(angle);
            } else {
                platform newPlatform;
                newPlatform.ptr = rect;
                newPlatform.id = myApp->idCounter;
                myApp->idCounter = myApp->idCounter + 1;
                newPlatform.startingAngle = myApp->currentRectangle.angle;
                newPlatform.timesBeforeExpire = 0;
                if (myApp->rotatingRectangles){
                    newPlatform.rotating = true;
                } else {
                    newPlatform.rotating = false;
                }
                myApp->rectangles.push_back(newPlatform);
                
                // also add to check point data
                b2Transform transform = newPlatform.ptr->body->GetTransform();
                b2Vec2 position = transform.p;
                float angle = transform.q.GetAngle();
                myApp->checkPointRec.push_back(angle);
            }
            break;
        }
        case SELECTION:
            // Dealing with dragging streams/portals so that the inital one disappears but the intermittent is always drawn, and then when released gets added in
            myApp->selected.dragged = false;
            if (myApp->selected.mode == STREAM){
                myApp->streams.push_back(myApp->selected.intermittent);
            } else if (myApp->selected.mode == PORTAL_IN){
                portal p;
                p.coordinates = myApp->selected.intermittent;
                p.pairNumber = myApp->selected.metaInt;
                myApp->inPortals.push_back(p);
            } else if (myApp->selected.mode == PORTAL_OUT){
                portal p;
                p.coordinates = myApp->selected.intermittent;
                p.pairNumber = myApp->selected.metaInt;
                myApp->outPortals.push_back(p);
            }
            break;

        default:
            break;
    }
}

